
Redmine - Defect #26892

Link to user in wiki syntax only works when login is written in lower case

2017-09-12 12:10 - Anders Thomsen

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Jean-Philippe Lang % Done: 0%

Category: Text formatting Estimated time: 0.00 hour

Target version: 4.0.0   

Resolution: Fixed Affected version: 3.4.2

Description

Related: #4179

The plugin "Redmine Mentions" gives a handy dropdown with users when hitting "@" on the keyboard. Selecting a user puts

"@loginname" in the textbox. This works great with the feature implemented in #4179. However, if the user's login contains capital

letters it is not recognized by the regex in application_helper.

"Redmine mentions" puts in the actual login-name with exact casing (what I believe is the correct behaivour).

The regex should be ajusted to a-zA-Z

Related issues:

Related to Redmine - Feature #4179: Link to user in wiki syntax Closed 2009-11-08

Has duplicate Redmine - Defect #32382: Unreliable User mention feature with P... Closed

Blocked by Redmine - Defect #26443: User link syntax (user:login) doesn't wor... Closed

Associated revisions

Revision 17516 - 2018-09-23 16:55 - Jean-Philippe Lang

Link to user in wiki syntax only works when login is written in lower case (#26892).

Patch by Marius BALTEANU and Go MAEDA.

History

#1 - 2017-09-24 13:46 - Go MAEDA

- Related to Feature #4179: Link to user in wiki syntax added

#2 - 2017-10-11 17:24 - Toshi MARUYAMA

- Target version set to 4.1.0

#3 - 2018-04-08 09:37 - Marius BĂLTEANU

- Blocked by Defect #26443: User link syntax (user:login) doesn't work for logins consisting of an email adress added

#4 - 2018-04-08 09:38 - Marius BĂLTEANU

- File 0001-user-link-syntax-should-work-also-with-logins-in-upp.patch added

Attached is a patch that fixes this issue and it should be applied after #26443.

#5 - 2018-04-08 09:39 - Marius BĂLTEANU

- Status changed from New to Confirmed

#6 - 2018-06-17 07:56 - Jean-Philippe Lang

- Assignee set to Marius BĂLTEANU

Marius, I have applied #26443 and I'm getting a failure for the test included in this patch:

Failure:

ApplicationHelperTest#test_redmine_links [test/helpers/application_helper_test.rb:406]:
user:JSMITH failed.

Expected: "<p><a class=\"user active\" href=\"/users/2\">John Smith</a></p>" 

  Actual: "<p>user:JSMITH</p>" 

 Can you have a look please?

#7 - 2018-06-17 16:28 - Go MAEDA

Jean-Philippe Lang wrote:

Marius, I have applied #26443 and I'm getting a failure for the test included in this patch:

 This is a workaround for the error.

Index: app/helpers/application_helper.rb

===================================================================

--- app/helpers/application_helper.rb    (revision 17395)

+++ app/helpers/application_helper.rb    (working copy)

@@ -975,12 +975,12 @@

                 link = link_to_project(p, {:only_path => only_path}, :class => 'project')

               end

             when 'user'

-              u = User.visible.where(:login => name, :type => 'User').first

+              u = User.visible.where("LOWER(login) = :s AND type = 'User'", :s => name.downcase).first

               link = link_to_user(u, :only_path => only_path) if u

             end

           elsif sep == "@" 

             name = remove_double_quotes(identifier)

-            u = User.visible.where(:login => name, :type => 'User').first

+            u = User.visible.where("LOWER(login) = :s AND type = 'User'", :s => name.downcase).first

             link = link_to_user(u, :only_path => only_path) if u

           end

         end

#8 - 2018-06-17 21:15 - Marius BĂLTEANU

- Assignee deleted (Marius BĂLTEANU)

- Target version changed from 4.1.0 to 4.0.0

I agree with the workaround posted above by Go Maeda, it is enough to fix the failing test. It seems that on my local environment, the search is case

insensitive and the test doesn't fail.

#9 - 2018-06-18 07:33 - Go MAEDA

- Assignee set to Jean-Philippe Lang

#10 - 2018-09-23 16:55 - Jean-Philippe Lang

- Status changed from Confirmed to Closed

- Resolution set to Fixed

Committed, thanks.

#11 - 2019-11-09 17:40 - Mischa The Evil

- Related to Defect #32382: Unreliable User mention feature with PostgreSQL added

#12 - 2020-04-14 05:26 - Marius BĂLTEANU

- Related to deleted (Defect #32382: Unreliable User mention feature with PostgreSQL)

#13 - 2020-04-14 05:26 - Marius BĂLTEANU

- Has duplicate Defect #32382: Unreliable User mention feature with PostgreSQL added

Files

0001-user-link-syntax-should-work-also-with-logins-in-upp.patch 1.79 KB 2018-04-08 Marius BĂLTEANU
